/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.testframework.web;

import junit.framework.TestCase;
import org.apache.cactus.server.FilterConfigWrapper;
import org.apache.cactus.server.HttpServletRequestWrapper;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;


/**
 * This class contains the unit tests for {@link TCFilterTestCase}.
 *
 * @author TCSDEVELOPER
 * @version 1.0
 */
public class TCFilterTestCaseTest extends TestCase {
    /**
     * This is a name used in test cases.
     */
    private static final String NAME = "testxxNamexx";
    /**
     * This is the instance to be tested. It is created in {@link #setUp()}.
     */
    private TCFilterTestCase testCase;

    /**
     * This method tests {@link TCFilterTestCase#TCFilterTestCase()} for correctness.
     */
    public void testNoArgCtor() {
        final TCFilterTestCase instance = new TCFilterTestCase();
        assertNull("constructor does not assign all fields", instance.getConfig());
        assertNull("constructor does not assign all fields", instance.getFilterChain());
        assertNull("constructor does not assign all fields", instance.getRequest());
        assertNull("constructor does not assign all fields", instance.getResponse());
        assertNull("constructor does not assign all fields", instance.getName());
    }

    /**
     * This method tests {@link TCFilterTestCase#TCFilterTestCase(String)} for correctness.
     */
    public void testOneArgCtor() {
        final TCFilterTestCase instance = new TCFilterTestCase(NAME);
        assertNull("constructor does not assign all fields", instance.getConfig());
        assertNull("constructor does not assign all fields", instance.getFilterChain());
        assertNull("constructor does not assign all fields", instance.getRequest());
        assertNull("constructor does not assign all fields", instance.getResponse());
        assertEquals("constructor does not assign all fields", NAME, instance.getName());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCFilterTestCase#getConfig()} for correctness.
     */
    public void testGetConfig() {
        assertNull(testCase.getConfig());
        final FilterConfigWrapper configWrapper = new FilterConfigWrapper(null);
        testCase.config = configWrapper;
        assertEquals(configWrapper, testCase.getConfig());
    }

    /**
     * This method tests {@link TCFilterTestCase#getFilterChain()} for correctness.
     */
    public void testGetFilterChain() {
        assertNull(testCase.getFilterChain());
        final FilterChain filterChain = new FilterChain() {
            public void doFilter(final ServletRequest servletRequest, final ServletResponse servletResponse)
                throws IOException, ServletException {
            }
        };
        testCase.filterChain = filterChain;
        assertEquals(filterChain, testCase.getFilterChain());
    }

    /**
     * This method tests {@link TCFilterTestCase#getRequest()} for correctness.
     */
    public void testGetRequest() {
        assertNull(testCase.getRequest());
        final HttpServletRequestWrapper requestWrapper = new HttpServletRequestWrapper(null, null);
        testCase.request = requestWrapper;
        assertEquals(requestWrapper, testCase.getRequest());
    }

    /**
     * This method tests {@link com.topcoder.testframework.web.TCFilterTestCase#getResponse()} for correctness.
     */
    public void testGetResponse() {
        assertNull(testCase.getResponse());

        final HttpServletResponse response = new DummyHttpServletResponse();
        testCase.response = response;
        assertEquals(response, testCase.getResponse());
    }

    /**
     * This method does the test setup needed.
     *
     * @throws Exception in case some unexpected Exception occurs
     */
    protected void setUp() throws Exception {
        super.setUp();
        testCase = new TCFilterTestCase();
    }

}
